local isHitedPed = {}

local Coord = { -- Coordinate = {areaCode, X, Y, Z}, Room = {X1, Y1, X2, Y2}
	HarringtonHouse = {
        InDoor = {32, -572.9, 134, 46.15},
        Room1_1 = {-561.7, 138.5, -570.67, 128.3},
        Room1_2 = {-533, 136.4, -557.3, 128.9},
        Room2_1 = {-521.77, 145.54, -545.7, 141.85},
        Room2_2 = {-521.8, 148.64, -530, 120.5},
        Room2_3 = {-504, 117, -526.1, 112.8},
        Room3_1 = {-504.55, 136.3, -507.88, 112.95},
        Room3_2 = {-512.25, 145.3, -515.76, 121.14},
        Room3_3 = {-518.5, 142.5, -541.88, 125},
        Room3_4 = {-545, 142.7, -547.4, 124.2},
        Door1 = {32, -545, 138.6, 46.15},
        Door2 = {32, -534.8, 125.7, 46.15},
        Door3 = {32, -531.86, 123.65, 50.72}
    }
}
local preps = {30, 31, 34, 40, 35, 32, 33, 37, 38}
local spawnedPreps = {"N_Darby", "N_Bif", "N_Chad", "N_Tad", "N_Justin", "N_Parker", "N_Pinky", "N_Bryce", "N_Gord"}

local pedInCombat = false
local russellInCombat = false
local nerdCombat = false
local attackBossTed = false
local bossTedActive = false
local bossJohnny = false
local bossGary = false
local fightDamon = false
local superThrow = false
local testFlag84 = false
local nutCracker = false 
local nutKick = false
local cheapShot = 0
local cheapShot2 = 0
local mascotKick = 0
local timer = 0
local attackTimer = 0
local spawnMascot = false
local stopMascot = false
--local spawnLocation = {
local mascotTime = 0
local dancingMascot = 0
local mascotStop = 0
--local fieldPositions = {
		--{-12,-100,1},
		--{-10,-45,1},
	--}
local mascotMove = false
local mascotDance = false
local mascot Dead = false
local deSpawnPed = false
local spawnJanitor = false
local janitorTime = 0
local janitorDead = false
local janitorMoving = false
local basePositions = {
		{-770,-64,12.37},
		{-772,-125,7.38},
		{-756,-153,7.4},
		{-765,-127,7.4},
		{-772,-85.4,7.4},
		{-757,-50.5,9.5},
		{-754,-79.3,8.7},
		{-742,-83.9,8.1},
		{-742,-63.8,8.7},
		{-738,-45.9,9.3},
}
local janitorMove = 0
local despawnJanitor = false
local relocateJanitor = false
local despawnMascot = false
local relocateMascot = false
local chasingJanitor = 0
local nerdMelee = false
local daytime = 0
local finisher = false
local shoulderCombo = false
local darbyCombo = false
local johnnyCombo = false
local principalDead = false
local spawnPrincipal = false
local chasingPrincipal = 0
local cutscenePrincipal = false
local relocatePrincipal = false
local returnPrincipal = false
local outoffOffice = true
local principalTime = 0
local attitudeAdjustment = false
local jockBob = false
local jockStyleBob = false
local doGrappling = false
local DOGrappleTime = 0
local spawnHH = false
local spawnPreps = 9
local hhGord = nil
local hhTad = nil
local hhParker = nil
local hhJustin = nil
local hhBryce = nil
local hhChad = nil
local hhBif = nil
local hhDarby = nil
local prepInteracting = false
local prepTalk1 = false
local prepTalk2 = false
local hhspawnTimer = 60000
local hhspawnInterval = 0
local darbyCounter = false

function main()
	while not SystemIsReady() do
		Wait(0)
	end
	--local playerBusted = 0
	OfficeOutsideBlip = BlipAddXYZ(-629.5171509,-280.8648682,5,7,2,12)
	OfficeInsideBlip = BlipAddXYZ(-701.2000122,216.6999969,31,7,2,12)
	BoysDormInsideBlip = BlipAddXYZ(-502.8657837,329.8096619,31,7,2,12)
	BoysDormOutsideBlip = BlipAddXYZ(276.4747925,-137.654892,6,7,2,12)
	if IsMissionCompleated("3_05") then
		TenementsOutsideBlip = BlipAddXYZ(583.6,-472.0,4.5,7,2,12)
	end
	if IsMissionCompleated("4_B2") then
		ObservatoryInsideBlip = BlipAddXYZ(-696.3,67.0,20.3,7,2,12)
		ObservatoryOutsideBlip = BlipAddXYZ(48.0,-134.1,3.0,7,2,12)
	end
	if IsMissionCompleated("6_B") then
		attitudeBlip = BlipAddXYZ(-497.917, 309.401 ,31 ,7,2,9)
		PedSetTypeToTypeAttitude(1,13,4) --nerds
		PedSetTypeToTypeAttitude(2,13,4) --jocks
		PedSetTypeToTypeAttitude(3,13,4) --townies
		PedSetTypeToTypeAttitude(4,13,4) --greasers
		PedSetTypeToTypeAttitude(5,13,4) --preps
		PedSetTypeToTypeAttitude(11,13,4) --bullies
	end
	--local spawnRoof = false
		while true do 
		AreaSetDoorLocked(TRIGGER._DT_ischool_PrincipalDoorL, false)
		Interiors()
		MainModPedReadjustment()
		AreaPedSpawn()

		
		for ped,v in pairs(isHitedPed) do
			if (PedGetNodeTime(PedGetWhoHitMeLast(ped)) <= 0.1 and not PedIsPlaying(PedGetWhoHitMeLast(ped),"/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight/HeavyRight_LAND",true)) or not PedIsValid(PedGetWhoHitMeLast(ped)) or PedGetHealth(ped) <= 0 then
				isHitedPed[ped] = nil
			end
		end
	Wait(0)
	end
end


MainModPedReadjustment = function()
	FindX, FindY, FindZ = PlayerGetPosXYZ()
		--TextPrintString("Finding peds matching specified conditions...", 1, 1) 
		--TextPrintString("X: "..FindX.."\nY: "..FindY.."\nZ: "..FindZ, 1, 1)
		--TextPrintString(daytime, 1, 1)
		for i, ped in ({PedFindInAreaXYZ(FindX, FindY, FindZ, 80)}) do 
			if i ~= gPlayer and not PedIsDead(ped) then  
				--if (HitIsPlaying(ped,"/Global/J_Mascot/Offense/Medium/Strikes/LightAttacks/WindMill_R/WindMill_L") or HitIsPlaying(ped,"/Global/Crazy_Basic/Offense/Short/Short/Strikes/LightAttacks/WindMill_R/WindMill_L")) and PedGetNodeTime(ped) >= 0.12 and not PedIsPlaying(PedGetWhoHitMeLast(ped),"/Global/J_Mascot/Offense/Medium/Strikes/LightAttacks/WindMill_R/WindMill_L/HeavyAttacks/SwingPunch_R",true) and not PedIsPlaying(PedGetWhoHitMeLast(ped),"/Global/Crazy_Basic/Offense/Short/Short/Strikes/LightAttacks/WindMill_R/WindMill_L/HeavyAttacks/SwingPunch_R",true) and not PedIsPlaying(ped,"/Global/HitTree/Standing/Melee/Generic/Left/HEADHOOK",true) then
					--PedApplyDamage(PedGetTargetPed(ped), 10 * PedGetDamageGivenMultiplier(ped, 2))
					--isHitedPed[ped] = true
				--end
				if HitIsPlaying(ped,"/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight") and not PedIsPlaying(ped,"/Global/HitTree/Standing/Melee/Generic/Straight/HEAVYSTRAIGHT2",true) then
					PedApplyDamage(ped,15 * PedGetDamageGivenMultiplier(ped, 2))
					isHitedPed[ped] = true
				end --adapted from mhdt

				if PedGetFaction(ped) == 5 then 
					--TextPrintString("Found a prep!", 1, 1)
						if PedGetName(ped) == "N_Darby" then
							local boxingHook = math.random(750)
							local chaseUppercut = math.random(1000)
							local evadeFreq = GameGetPedStat(ped,13)
							--local dodgeChance = math.random(100)
							--local comboPuch = math.random(200)
							--PedSetDamageGivenMultiplier(ped,2,1.50)	
							if MissionActiveSpecific("2_B") then
								PedOverrideStat(ped,13,50)
								PedOverrideStat(ped,34,30)
								if PedGetMaxHealth(ped) < 650 then
									PedSetHealth(ped,650)
								end
							elseif not pedInCombat and not MissionActiveSpecific("2_B") then
								if PedIsInCombat(ped) then
									LoadAnimationGroup("Straf_Prep")
									LoadAnimationGroup("P_Striker")
									LoadAnimationGroup("P_Grappler")
									LoadAnimationGroup("Boxing")
									--ImportScript("2_B.lua")
									PedSetActionTree(ped, "/Global/BOSS_Darby", "Act/Anim/BOSS_Darby.act")
									PedSetAITree(ped, "/Global/DarbyAI", "Act/AI/AI_DARBY_2_B.act")
									PedOverrideStat(ped,13,50)
									PedOverrideStat(ped,34,30)
									PedOverrideStat(ped,38,50)
									PedOverrideStat(ped,39,50)
									pedInCombat = true
								end
							elseif PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"/Global/BOSS_Darby/Offense/Short/Grapples/HeavyAttacks/Catch_Throw",true) and not PedIsPlaying(ped,"/Global/BOSS_Darby/Offense/Short/Grapples",true) and not PedMePlaying(ped,"Sprint",true) then
								if boxingHook == 70 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
									PedSetActionNode(ped, RandomTableElement({
										"/Global/BOSS_Darby/Offense/Special/HeavyAttacks",
										"/Global/BOSS_Darby/Offense/Special/HeavyAttacks"
									}),"Act/Anim/BOSS_Darby.act")
								
								--elseif boxingHook == 300 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
									--	PedSetActionNode(ped,"/Global/P_Grappler_A/Offense/Short/Strikes/HeavyAttacks/RightCross","Act/Anim/P_Grappler_A.act")	
								--elseif boxingHook == 100 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 and not darbyCombo then
									--TextPrintString("Darby Combo!", 1, 1)
									--PedSetActionNode(ped,"/Global/BOSS_Darby/Offense/Medium/Medium/HeavyAttacks/JAB","Act/Anim/BOSS_Darby.act")
								--	darbyCombo = true
								--elseif PedIsPlaying(ped,"/Global/BOSS_Darby/Offense/Medium/Medium/HeavyAttacks/JAB",true) and PedGetNodeTime(ped) >= 0.5 and darbyCombo or not PedIsPlaying(ped,"/Global/BOSS_Darby/Offense/Medium/Medium/HeavyAttacks/JAB",true) and darbyCombo then
									--local darbyComboFinisher = math.random(4)
									--if darbyComboFinisher == 1 then
									--	PedSetActionNode(ped, RandomTableElement({
										--	"/Global/BOSS_Darby/Offense/Special/HeavyAttacks",
									--		"/Global/BOSS_Darby/Offense/Special/HeavyAttacks"
									--	}),"Act/Anim/BOSS_Darby.act")
								--	elseif darbyComboFinisher == 2 then
									--	PedSetActionNode(ped,"/Global/BOSS_Darby/Offense/Short/Strikes/LightAttacks/LeftHook","Act/Anim/BOSS_Darby.act")
									--elseif darbyComboFinisher == 3 then
										--PedSetActionNode(ped,"/Global/P_Grappler_A/Offense/Short/Strikes/HeavyAttacks/RightCross","Act/Anim/P_Grappler_A.act")	
									--elseif darbyComboFinisher == 4 then
									--	PedSetActionNode(ped,"/Global/BOSS_Darby/Defense/Evade/EvadeDuck/HeavyAttacks/EvadeDuckPunch","Act/Anim/BOSS_Darby.act")
									--end
									--darbyCombo = false
								elseif boxingHook == 500 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then --and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) >= 1.5 then
									--TextPrintString("Chase Uppercut!", 1, 1)
									--ImportScript("2_B.lua")
									PedSetActionNode(ped,"/Global/BOSS_Darby/Defense/Evade/EvadeDuck/HeavyAttacks/EvadeDuckPunch","Act/Anim/BOSS_Darby.act")
									--PedSetActionNode(ped,"/Global/BOSS_Darby_A/Offense/Short/DashToUppercut","Act/Anim/BOSS_Darby.act")
								end
								if PedIsHit(ped) and PedIsPlaying(ped,"/Global/BOSS_Darby/Defense/Block/Block",true) and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then --and not PedIsPlaying(ped,"Hold_Idle") and not PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
									--TextPrintString("Dodge Darby!", 1, 1)
									local dodgeChance = math.random(100)
									local counterRate = math.random(10)
									if dodgeChance <= evadeFreq then
										if counterRate > 3 then
											PedSetActionNode(ped,"/Global/P_Striker_B/Defense/Evade/EvadeBack/EvadeBack","Act/Anim/P_Striker_B.act")
										elseif counterRate <= 3 and not darbyCounter then
											--TextPrintString("Counter Darby!", 1, 1)
											--PedSetActionNode(ped,"/Global/BOSS_Darby/Defense/Evade/EvadeDuck/HeavyAttacks","Act/Anim/BOSS_Darby.act")
											PedSetActionNode(ped,"/Global/P_Striker_B/Defense/Evade/EvadeBack/EvadeBack","Act/Anim/P_Striker_B.act")
											darbyCounter = true
										end
									end
								end
								if darbyCounter and not PedIsPlaying(ped,"/Global/P_Striker_B/Defense/Evade/EvadeBack/EvadeBack",true) then
									local counterMove = math.random(10)
									--if counterMove > 6 then
										--PedSetActionNode(ped,"/Global/BOSS_Darby/Defense/Evade/EvadeDuck/HeavyAttacks","Act/Anim/BOSS_Darby.act")
									if counterMove <= 5 and counterMove > 3  then
										PedSetActionNode(ped,"/Global/BOSS_Darby/Offense/Short/Strikes/HeavyAttacks","Act/Anim/BOSS_Darby.act")
									elseif counterMove >= 5  then
										PedSetActionNode(ped,"/Global/BOSS_Darby/Offense/Short/Grapples/HeavyAttacks","Act/Anim/BOSS_Darby.act")
									end
									darbyCounter = false
								end
							elseif not PedIsInCombat(ped) and not MissionActiveSpecific("2_B") then
								PedSetAITree(ped,"/Global/AI","Act/AI/AI.act")
								pedInCombat = false
							end
						elseif PedIsModel(ped,32) or PedIsModel(ped,35) or PedIsModel(ped,178) then
							PedSetDamageGivenMultiplier(ped,2,1.50)
							if PedGetMaxHealth(ped) < 135 then
								PedSetHealth(ped, 135)
							end
							if PedIsInCombat(ped) then
								if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
									PedSetActionNode(ped,unpack(RandomTableElement({
										{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitA","Act/Globals.act"},
										{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
										{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitC","Act/Globals.act"},
										{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
									})))
								elseif PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
									PedSetActionNode(ped,unpack(RandomTableElement({
										{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Globals.act"},
									})))
								end
							elseif MissionActiveSpecific("6_03") then
								if PedGetMaxHealth(ped) < 300 then
									PedSetHealth(ped,300)
								end
							end
						elseif PedGetName(ped) == "N_Bif" then
							PedSetDamageGivenMultiplier(ped,2,1.20)
							if MissionActiveSpecific("2_08") then
								if PedGetMaxHealth(ped) < 500 then
									PedSetHealth(ped,500)
								end
							end
						elseif MissionActiveSpecific("2_07") then
							if PedGetName(ped) == "N_Gord" or PedGetName(ped) == "N_Chad" then
								if PedGetMaxHealth(ped) < 300 then
									PedSetHealth(ped,300)
								end
							end
						end
				elseif PedGetFaction(ped) == 2 then 
					--TextPrintString("Found a Jock!", 1, 1)
						if PedGetName(ped) == "N_Damon" then
							PedSetDamageGivenMultiplier(ped,2,1.50)
							--local damonDestroy = math.random(500)
							local dumpTruckTackle = math.random(1000)
							--local damonSmash = math.random(2)
							--local footDamon = math.random(50)
							if PedGetMaxHealth(ped) < 500 then
								PedSetHealth(ped, 500)
							end
							if not fightDamon then
								if PedIsInCombat(ped) then
									LoadAnimationGroup("J_Melee")
									fightDamon = true
								end
							elseif PedIsInCombat(ped) then
								if not shouldIgnoreTarget(ped) and not MissionActiveSpecific("4_B2") and not PedIsPlaying(ped,"Hold_Idle") and not PedMePlaying(ped,"Sprint",true) and not GrappleAnimationPlaying(ped) and not PedIsPlaying(ped, "/Global/J_Damon/Offense/Medium/Grapples/GrapplesAttempt/TakeDown", true) and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
									--if damonDestroy == 80 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
										--PedSetActionNode(ped,"/Global/J_Striker_A/Offense/Short/Strikes/LightAttacks/JAB/Elbow/HeavyAttacks/Uppercut","Act/Anim/J_Striker_A.act")
									--elseif damonDestroy == 100 and not isPedOnGround(ped) then
										--PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleAttempt","Act/Globals.act")
									if dumpTruckTackle == 200 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) > 1  and not PedIsPlaying(ped, "/Global/J_Damon/Offense/Medium/Grapples/GrapplesAttempt/TakeDown", true) then
										--PedLockTarget(ped, PedGetTarget(ped), 3)
										PedSetActionNode(ped,"/Global/J_Damon/Offense/SpecialStart/StartRun", "Act/Anim/J_Damon.act")
									elseif dumpTruckTackle == 90 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
										PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/Unblockable", "Act/Anim/J_Melee_A.act")
									--elseif PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) then
										--PedSetActionNode(ped,unpack(RandomTableElement({
										--	{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/PowerBomb/GIVE","Act/Globals.act"},
										--	{"/Global/J_Damon/Offense/Medium/Grapples/GrapplesAttempt/TakeDown/PowerSwing","Act/Anim/J_Damon.act"},
										--	{"/Global/Actions/Grapples/GrappleReversals/StandingReversals/Sprawl/GIVE","Act/Globals.act"},
										--})))
									--elseif PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
										--PedSetActionNode(ped,"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act")
									end
								end
							elseif not PedIsInCombat(ped) then
								fightDamon = false
							end
							if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act")
							end
							if MissionActiveSpecific("4_B2") then
								if PedGetMaxHealth(ped) < 500 then
									PedSetHealth(ped,500)
									--PedSetDamageTakenMultiplier(ped,3,0.75)
								end
							end
						elseif PedGetName(ped) == "N_Ted" then
							PedSetDamageGivenMultiplier(ped,2,1.25)
							local tedAttack =  math.random(500)
							local tedBarge = math.random(1000)
							--local extraAttack = math.random(500)
							--if PedIsInCombat(ped) and not MissionActiveSpecific("4_B2") then
								--if extraAttack == 60 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
									--PedSetActionNode(ped,"/Global/J_Striker_A/Offense/Short/Strikes/LightAttacks/JAB/Elbow/HeavyAttacks/Uppercut","Act/Anim/J_Striker_A.act")
								--end
							if PedGetMaxHealth(ped) < 500 and not MissionActiveSpecific("4_B2") then
								PedSetHealth(ped, 500)
							end
							if not attackBossTed then
								if PedIsInCombat(ped) then
									LoadAnimationGroup("J_Melee")
									LoadAnimationGroup("J_Grappler")
									if MissionActiveSpecific("6_03") then
										LoadAnimationGroup("Boxing")
										LoadAnimationGroup("J_Ranged")
										PedSetActionTree(ped, "/Global/J_Ted", "Act/Anim/J_Ted.act")
										PedSetWeapon(ped, 400, 1)
										if PedGetMaxHealth(ped) < 950 then
											PedSetHealth(ped, 950)
										end
									end
									attackBossTed = true
								end
							elseif PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"Hold_Idle") and not PedMePlaying(ped,"Sprint",true) and not GrappleAnimationPlaying(ped) and not MissionActiveSpecific("4_B2") and not PedHasWeapon(ped, 400) and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								if tedAttack == 150 then
									PedSetActionNode(ped,"/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight", "Act/Anim/J_Melee_A.act")
								elseif tedAttack == 300 then
									PedSetActionNode(ped,RandomTableElement({
										"/Global/J_Grappler_A/Offense/Short/Strikes/HeavyAttacks",
										"/Global/J_Grappler_A/Offense/Medium/Strikes/HeavyAttacks/RightPunch/Axehandle",
									}),"Act/Anim/J_Grappler_A.act")
								elseif tedAttack == 100 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
										PedSetActionNode(ped,"/Global/J_Melee_A/Offense/Short/Strikes/LightAttacks","Act/Anim/J_Melee_A.act")	
								elseif tedBarge == 90 and not tedAttack == 100 and not tedAttack == 300 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
										PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/Unblockable", "Act/Anim/J_Melee_A.act")
								--elseif PedIsPlaying(ped,"/Global/J_Ted/Offence/Medium/Grapples/GrapplesAttempt", true) then
									--PedSetActionNode(ped, "/Global/J_Striker_A/Offense/Medium/Grapples/GrapplesAttempt","Act/Anim/J_Striker_A.act")
								--elseif PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) then
								--	PedSetActionNode(ped,unpack(RandomTableElement({
									--	{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BodySlam","Act/Globals.act"},
									--	{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
									--	{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BackBreaker/Give","Act/Globals.act"},
									--})))
								
								--elseif PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								--	PedSetActionNode(ped,unpack(RandomTableElement({
									--	{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Globals.act"},
									--	{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
									--})))
								elseif tedBarge == 200 and not tedAttack == 100 and not tedAttack == 300 and not shoulderCombo then
									--TextPrintString("Wombo Combo!", 1, 1)
									PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight", "Act/Anim/J_Melee_A.act")
									shoulderCombo = true
								elseif not PedIsPlaying(ped,"/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight", true) and shoulderCombo then
									PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/Unblockable", "Act/Anim/J_Melee_A.act")
									shoulderCombo = false								
								--elseif tedBarge == 150 and not tedAttack == 100 and not tedAttack == 300 and MissionActiveSpecific("6_03") and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) >= 3 then
									--PedSetWeapon(ped, 400, 1)
								end
							elseif not PedIsInCombat(ped) then
								attackBossTed = false
							--elseif MissionActiveSpecific("4_B2") and PedIsModel(ped,110) then
								--bossTedActive = true
								--if PedGetMaxHealth(ped) == 5 then
									--SoundPlayStream("MS_JockBossBattle.rsm", 1)
									--PedSetHealth(ped,650)
									--PedSetMaxHealth(ped,650)
									--LoadAnimationGroup("Boxing")
									--PedSetActionTree(ped, "/Global/J_Ted", "Act/Anim/J_Ted.act")
									--attackBossTed = false
									--PedIgnoreStimuli(ped, false)
								--elseif PedGetMaxHealth(ped) == 650 then
									--if not attackBossTed then
									--if PedIsValid(ped) and not PedIsDead(ped) then
										--print("Attempting to trigger attack")
										--PedSetPedToTypeAttitude(ped, 13, 0)
										--PedIgnoreAttacks(ped, false)
										--PedClearTether(ped)
										--PedAttackPlayer(ped,3)
										--bossTedActive = false
										--attackBossTed = true
										--print("Attack triggered")
									--end
									--end
								--end
							end
							if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
									PedSetActionNode(ped,unpack(RandomTableElement({
										{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Globals.act"},
										{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
									})))
							end
						elseif PedGetName(ped) == "N_Luis" or PedGetName(ped) == "N_Juri" or PedGetName(ped) == "N_Bob" then
							PedSetDamageGivenMultiplier(ped,2,1.40)
							local headButt = math.random(2)
							if PedGetMaxHealth(ped) < 200 then
								PedSetHealth(ped, 200)
							end
							if PedIsInCombat(ped) then
								if not jockStyleBob and PedGetName(ped) == "N_Bob" then
									PedSetActionTree(ped, "/Global/J_Grappler_A", "Act/Anim/J_Grappler_A.act")
									LoadAnimationGroup("J_Grappler")
									LoadAnimationGroup("F_Jocks")
									jockStyleBob = true
								end
								if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
									if PedGetName(ped) == "N_Luis" then
										--PedSetActionNode(ped, "/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BodySlam","Act/Globals.act")
										PedSetActionNode(ped,unpack(RandomTableElement({
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BodySlam","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
										})))
									elseif PedGetName(ped) == "N_Juri" then
										--PedSetActionNode(ped, "/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BackBreaker/Give","Act/Globals.act")
										PedSetActionNode(ped,unpack(RandomTableElement({
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BackBreaker/Give","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
											})))
									elseif PedGetName(ped) == "N_Bob" then
										if headButt == 1 then
											PedSetActionNode(ped, "/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BearHug","Act/Globals.act")
										--{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TandemGrapple/TandemGrapple_ACTIVE/GIVE","Act/Globals.act"},
										else
											PedSetActionNode(ped,unpack(RandomTableElement({
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitA","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitC","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
											})))
										end
									end
								elseif PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
									if PedGetName(ped) == "N_Luis" or PedGetName(ped) == "N_Juri" then
										--PedSetActionNode(ped,"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act")
										PedSetActionNode(ped,unpack(RandomTableElement({
											{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Globals.act"},
											{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
										})))
									elseif PedGetName(ped) == "N_Bob" then
										PedSetActionNode(ped,"/Global/Actions/Grapples/Mount/GrappleMoves/Headbutt","Act/Globals.act")										
									end
								end
							elseif not PedIsInCombat(ped) and PedGetName(ped) == "N_Bob" then
								jockStyleBob = false
							end
						elseif PedGetName(ped) == "N_Bo" or PedGetName(ped) == "N_Casey" then
							--PedSetDamageGivenMultiplier(ped,2,1.20)
							local shoulderSlam = math.random(1000)
							if PedGetMaxHealth(ped) < 200 and PedGetName(ped) == "N_Casey" then
								PedSetHealth(ped, 200)
							end
							if PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"Sprint",true) and not PedIsPlaying(ped,"Hold_Idle") and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								if shoulderSlam == 50 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
									PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/Unblockable", "Act/Anim/J_Melee_A.act")
								
								elseif shoulderSlam == 200 and not shoulderCombo then
									--TextPrintString("Wombo Combo!", 1, 1)
									PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight", "Act/Anim/J_Melee_A.act")
									shoulderCombo = true
								elseif not PedIsPlaying(ped,"/Global/J_Melee_A/Offense/Medium/Strikes/HeavyAttacks/HeavyRight", true) and shoulderCombo then
									PedSetActionNode(ped, "/Global/J_Melee_A/Offense/Medium/Strikes/Unblockable", "Act/Anim/J_Melee_A.act")
									shoulderCombo = false
								end
							
							end
							if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
								PedSetActionNode(ped,unpack(RandomTableElement({
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitA","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitC","Act/Globals.act"},
												{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
											})))
							end
							if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								PedSetActionNode(ped,unpack(RandomTableElement({
											{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Globals.act"},
											{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
										})))
							end
						end	
				elseif PedGetFaction(ped) == 4 then 
					--TextPrintString("Found a Greaser!", 1, 1)
						if PedGetName(ped) == "N_Norton" then
							PedSetDamageGivenMultiplier(ped,2,1.75)
							if PedGetMaxHealth(ped) < 450 then
								PedSetHealth(ped, 450)
							end
							if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
								PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BearHug","Act/Globals.act"},
									{"/Global/Actions/Grapples/GrappleReversals/StandingReversals/Sprawl/GIVE","Act/Globals.act"},
								})))
							elseif PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								--PedSetActionNode(ped, "/Global/Actions/Grapples/GrappleReversals/MountReversals/MountReversalPunches/GIVE","Act/Globals.act")
								PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/GrappleReversals/MountReversals/MountReversalPunches/GIVE","Act/Globals.act"},
									{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Anim/G_Grappler_A.act"},
								})))
							end
						elseif PedGetName(ped) == "N_Hal" then
							if PedGetMaxHealth(ped) < 200 then
								PedSetHealth(ped, 200)
							end
							if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
								PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BearHug","Act/Globals.act"},
									{"/Global/Actions/Grapples/GrappleReversals/StandingReversals/Sprawl/GIVE","Act/Globals.act"},
								})))
							elseif PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								--PedSetActionNode(ped, "/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Anim/G_Grappler_A.act")
								PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/GrappleReversals/MountReversals/MountReversalPunches/GIVE","Act/Globals.act"},
									{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Anim/G_Grappler_A.act"},
								})))
							end
						elseif PedGetName(ped) == "N_Peanut" then
							PedSetDamageGivenMultiplier(ped,2,1.20)
						elseif PedGetName(ped) == "N_Vance" then
							PedSetDamageGivenMultiplier(ped,2,1.20)
							if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleOpps/Melee/Greaser/GrabKnees/GV","Act/Anim/G_Melee_A.act")
							elseif MissionActiveSpecific("3_06") then
								if PedGetMaxHealth(ped) < 300 then
									PedSetHealth(ped,300)
								end
							end
						elseif PedGetName(ped) == "N_Lefty" then
							if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleOpps/Melee/Greaser/GrabKnees/GV","Act/Anim/G_Melee_A.act")
							end
						elseif PedGetName(ped) == "N_Johnny" then
							local tornado = math.random(1000)
							if not bossJohnny and not MissionActiveSpecific("3_B") then
								if PedIsInCombat(ped) then
									LoadAnimationGroup("G_Johnny")
									LoadAnimationGroup("G_Striker")
									PedSetActionTree(ped, "/Global/G_Johnny", "Act/Anim/G_Johnny.act")
									bossJohnny = true
								end
							end
							if PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedMePlaying(ped,"Sprint",true) and not PedIsPlaying(ped,"/Global/G_Johnny/Offense/Special/SpecialActions", true) then
								if tornado == 200 and DistanceBetweenPeds2D(PedGetTargetPed(ped), ped) <= 1.5 then
									PedSetActionNode(ped,"/Global/G_Johnny/Default_KEY/RisingAttacks/HeavyAttacks/RisingAttacks", "Act/Anim/G_Johnny.act")
								elseif tornado == 500 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 and not johnnyCombo then
									--TextPrintString("Johnny Combo!", 1, 1)
									PedSetActionNode(ped,"/Global/G_Johnny/Offense/Short/Strikes/LightAttacks","Act/Anim/G_Johnny.act")
									johnnyCombo = true
								--elseif PedIsPlaying(ped,"/Global/G_Johnny/Offense/Short/Strikes/LightAttacks",true) and PedGetNodeTime(ped) >= 1 and johnnyCombo or
								elseif not PedIsPlaying(ped,"/Global/G_Johnny/Offense/Short/Strikes/LightAttacks",true) and johnnyCombo then
									PedSetActionNode(ped,"/Global/G_Johnny/Default_KEY/RisingAttacks/HeavyAttacks/RisingAttacks", "Act/Anim/G_Johnny.act")
									johnnyCombo = false
								
								end
							elseif not PedIsInCombat(ped) then
									bossJohnny = false
							elseif MissionActiveSpecific("3_B") then
								if PedGetMaxHealth(ped) < 950 then
									PedSetHealth(ped,950)
								end
							end
						end
				elseif PedGetFaction(ped) == 3 then 
					--TextPrintString("Found a Dropout!", 1, 1)
					if PedGetName(ped) == "N_Edgar" then
						local edgarGrab = math.random(500)
						if MissionActiveSpecific("5_B") then
							PedSetDamageTakenMultiplier(ped,2,0.40)
							PedSetDamageTakenMultiplier(ped,3,0.40)
						end
						if PedIsInCombat(ped) and not MissionActiveSpecific("5_B") and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"Hold_Idle") and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) and not PedMePlaying(ped,"Sprint",true) and not GrappleAnimationPlaying(ped) then
							if edgarGrab == 100 and not doGrappling and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleAttempt","Act/Globals.act")
								doGrappling = true
							end
						end
						if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) and PedGetTargetPed(ped) == gPlayer then
							PedSetActionNode(ped,unpack(RandomTableElement({
								{"/Global/Actions/Grapples/Mount/GrappleMoves/Headbutt","Act/Globals.act"},
								{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
							})))
							doGrappling = true
							DOGrappleTime = GetTimer() + 5000
						end	
						if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
							PedSetActionNode(ped,unpack(RandomTableElement({
											{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
											{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitC","Act/Globals.act"},
											{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
										})))
							doGrappling = true
							DOGrappleTime = GetTimer() + 5000
						end
						if doGrappling and GetTimer() >= DOGrappleTime then
								doGrappling = false
						end
					elseif PedGetName(ped) == "N_Omar" then
						if PedGetMaxHealth(ped) < 300 then
							PedSetHealth(ped, 300)
						end
					elseif PedGetName(ped) == "N_Gurney" or PedGetName(ped) == "N_Jerry" or PedGetName(ped) == "N_Henry" or PedGetName(ped) == "N_Leon" then
						local doAttack = math.random(500)
						if PedGetMaxHealth(ped) < 600 and PedGetName(ped) == "N_Gurney" then
								PedSetHealth(ped, 600)
						end
						if PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"Hold_Idle") and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) and not PedMePlaying(ped,"Sprint",true) and not GrappleAnimationPlaying(ped) then
							--if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
								--doGrappling = true
								--PedSetActionNode(ped,unpack(RandomTableElement({
									--{"/Global/Actions/Grapples/Mount/GrappleMoves/Headbutt","Act/Globals.act"},
								--	{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
								--})))
							--	DOGrappleTime = GetTimer() + 8000
						--	end	
							if PedIsPlaying(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act",true) then
								doGrappling = true
								--DOGrappleTime = GetTimer() + 5000
							end
							if doAttack == 100 and not doGrappling and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleAttempt","Act/Globals.act")
								doGrappling = true
							end
						--	if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
							--	PedSetActionNode(ped,unpack(RandomTableElement({
						--						{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
						--						{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitC","Act/Globals.act"},
							--					{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
							--				})))
							--	DOGrappleTime = GetTimer() + 8000
							--end
							if doGrappling and GetTimer() >= DOGrappleTime then
								doGrappling = false
							end
						end
						if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) and PedGetTargetPed(ped) == gPlayer then
							PedSetActionNode(ped,unpack(RandomTableElement({
								{"/Global/Actions/Grapples/Mount/GrappleMoves/Headbutt","Act/Globals.act"},
								{"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE","Act/Globals.act"},
							})))
							doGrappling = true
							DOGrappleTime = GetTimer() + 5000
						end	
						if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
							PedSetActionNode(ped,unpack(RandomTableElement({
											{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Globals.act"},
											{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitC","Act/Globals.act"},
											{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
										})))
							doGrappling = true
							DOGrappleTime = GetTimer() + 5000
						end
					end
				elseif PedGetFaction(ped) == 6 then 
					--TextPrintString("Found a Student", 1, 1)
					if PedGetName(ped) == "N_Gary" then
						if not bossGary and not MissionActiveSpecific("6_B") then
							if PedIsInCombat(ped) then
								LoadAnimationGroup("Nemesis")
								PedSetActionTree(ped, "/Global/Nemesis", "Act/Anim/Nemesis.act")
								bossGary = true
							end
						elseif not PedIsInCombat(ped) then
							bossGary = false
						end
						if MissionActiveSpecific("6_B") then
							if PedGetMaxHealth(ped) < 1250 then
									PedSetHealth(ped,1250)
							end
						end
					elseif PedGetName(ped) == "N_Peter" then
						if IsMissionCompleated("C_ART_1") then
							PedSetFlag(ped, 84, true)
						end
						if PedIsPlaying(ped,"/Global/Player/Social_Actions/MakeOut/Makeout/GrappleAttempt", true) then
							if not testFlag84 and GetTimer() >= timer then
								SoundPlayScriptedSpeechEvent(ped,"SEE_SOMETHING_COOL",0,"supersize",true)
								timer = GetTimer() + 12000
								testFlag84 = true
							elseif testFlag84 and PedGetNodeTime(ped) >= 7.0 then --GetTimer() >= timer then
								--if math.random(1,2) == 1 then
									SoundPlayScriptedSpeechEvent(ped,"THANKS_JIMMY",0,"supersize",true)
								--else
									--SoundPlayScriptedSpeechEvent(ped,"SEE_SOMETHING_COOL",0,"supersize",true)
								--end
								testFlag84 = false
							end						--elseif not SoundSpeechPlaying() then
						--	testFlag84 = false
						end
					end
				elseif PedGetFaction(ped) == 11 then
					--TextPrintString("Found a Bully", 1, 1)
					if PedIsModel(ped,75)then
						local womboCombo = math.random(1000)
						local beserker = math.random(1500)
						local powerBomb = math.random(2)
						if not russellInCombat and not MissionActive() then
							if PedIsInCombat(ped) then
								--PedSetDamageGivenMultiplier(ped,2,1.50)
								LoadAnimationGroup("Russell")
								LoadAnimationGroup("STRAF_WREST")
								LoadAnimationGroup("C_Wrestling")
								PedSetActionTree(ped, "/Global/BOSS_Russell", "Act/Anim/Boss_Russell.act")
								PedSetAITree(ped, "/Global/RusselAI", "Act/AI/AI_RUSSEL_1_B.act")
								russellInCombat = true
							end
						
						elseif PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"/Global/BOSS_Russell/Offense/Special/Invincible",true) and not PedIsPlaying(ped,"Hold_Idle",true) and not PedIsPlaying(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/PowerBomb/Give",true) and not PedIsPlaying(ped,"Grapples",true) and not MissionActiveSpecific("2_05") and not MissionActiveSpecific("5_06") and not MissionActiveSpecific("5_07a") and not MissionActiveSpecific("5_B") then
							if womboCombo == 20 and DistanceBetweenPeds2D(PedGetTargetPed(ped), ped) <= 1.5 then
								PedSetActionNode(ped, "/Global/Russell_102/Offense/Short/Strikes/LightAttacks/WindMill_R", "Act/Anim/Russell_102.act")
							elseif womboCombo == 60 and DistanceBetweenPeds2D(PedGetTargetPed(ped), ped) <= 1.5 then
								PedSetActionNode(ped, "/Global/B_Striker_A/Offense/Short/Strikes/HeavyAttacks/GutKick/GutKick_R", "Act/Anim/B_Striker_A.act")
							elseif womboCombo == 900 and not MissionActive() then
								LoadAnimationGroup("Russell")
								LoadAnimationGroup("STRAF_WREST")
								LoadAnimationGroup("C_Wrestling")
								PedSetActionNode(ped, "/Global/BOSS_Russell/Offense/Special/Invincible/BarserkGrapple", "Act/Anim/Boss_Russell.act")
							--elseif womboCombo == 200 and not MissionActive() and not finisher and DistanceBetweenPeds2D(PedGetTargetPed(ped), ped) <= 1.5 then
								--TextPrintString("Wombo Combo!", 1, 1)
								--LoadAnimationGroup("Russell")
								--LoadAnimationGroup("STRAF_WREST")
								--LoadAnimationGroup("C_Wrestling")
								--PedSetActionNode(ped, "/Global/B_Striker_A/Offense/Short/Strikes/LightAttacks/WindMill_R", "Act/Anim/B_Striker_A.act")
								--finisher = true
							--elseif not PedIsPlaying(ped,"/Global/B_Striker_A/Offense/Short/Strikes/LightAttacks/WindMill_R", true) and finisher then
								--PedSetActionNode(ped, "/Global/BOSS_Russell/Offense/Medium/Strikes/Unblockable/DoubleAxeHandle", "Act/Anim/Boss_Russell.act")
								--finisher = false
							end
						elseif not PedIsInCombat(ped) and not MissionActiveSpecific("1_B") and not MissionActiveSpecific("5_06") and not MissionActiveSpecific("5_07a") and not MissionActiveSpecific("5_B") then
							PedSetDamageGivenMultiplier(ped,2,1.00)
							PedSetActionTree(ped,"/Global/B_Striker_A","Act/Anim/B_Striker_A.act")
							PedSetAITree(ped,"/Global/AI","Act/AI/AI.act")
							russellInCombat = false
						end
						if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) and PedGetTargetPed(ped) == gPlayer then
							if powerBomb == 2 then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/PowerBomb/Give","Act/Globals.act")
							else
								PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitB","Act/Anim/Player.act"},
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/DirectionalPush/PushFwd/Give","Act/Globals.act"},
								})))
							end
						end
					end
				elseif PedGetFaction(ped) == 1 then
					--TextPrintString("Found a Nerd", 1, 1)
					if PedGetName(ped) == "N_Earnest" then
						if not nerdCombat and not MissionActiveSpecific("4_B1") then
							if PedIsInCombat(ped) then
								PedSetWeaponNow(ped, 305, 20)
								LoadAnimationGroup("Earnest")
								PedSetActionTree(ped, "/Global/N_Earnest", "Act/Anim/N_Earnest.act")
								repeat
									Wait(0)
								until WeaponRequestModel(417)
								--PedOverrideStat(ped, 60, init)
								nerdCombat = true
							end
						elseif PedIsInCombat(ped) and not MissionActiveSpecific("4_B1") and not shouldIgnoreTarget(ped) and PedIsValid(ped) and not PedIsDead(ped) then 
							local throwBomb = math.random(1,400)
							local fireSpud = math.random(1,400)
							local Ex, Ey, Ez = PedGetPosXYZ(PedGetTargetPed(ped))
							local B = math.random(-3, 3)
							local C = math.random(-3, 3)
							--local D = math.random(-3, 3)
							if fireSpud == 4 and not PedIsPlaying(ped, "/Global/N_Earnest/Offense/ThrowBombs", true) then
							--TextPrintString("NerdLeader Fire", 1, 1)
								--firingSpud = true
								PedFaceObject(ped, PedGetTargetPed(ped), 3)
								--PedLockTarget
								PedSetWeaponNow(ped, 305, 20)
								PedSetActionNode(ped, "/Global/N_Earnest/Offense/FireSpudGun", "Act/Anim/N_Earnest.act")
								
							elseif throwBomb == 10 and not PedIsPlaying(ped, "/Global/N_Earnest/Offense/FireSpudGun", true) then
									--TextPrintString("NerdLeader Explode")
								--bombAction = true
								PedSetWeaponNow(ped, 417, 8)
								PedSetActionNode(ped, "/Global/N_Earnest/Offense/ThrowBombs", "Act/Anim/N_Earnest.act")
								--PedSetProjDest(ped, Ex + B, Ey + C, Ez)
								--Wait(2000)
								--bombAction = false
							
							end
							if PedIsPlaying(ped, "/Global/N_Earnest/Offense/ThrowBombs", true) and not MissionActiveSpecific("4_B1") then
								PedSetProjDest(ped, Ex + B, Ey + C, Ez)
							end
							if PedIsInCombat(ped) and not MissionActiveSpecific("4_B1") and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1 and not nerdMelee then
								PedSetActionTree(ped,"/Global/N_Ranged_A","Act/Anim/N_Ranged_A.act")
								nerdMelee = true
							
							elseif PedIsInCombat(ped) and not MissionActiveSpecific("4_B1") and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) > 1 and nerdMelee then
								PedSetActionTree(ped, "/Global/N_Earnest", "Act/Anim/N_Earnest.act")
								nerdMelee = false
							end
							
						elseif not PedIsInCombat(ped) and not MissionActiveSpecific("4_B1") and nerdCombat then
							PedSetActionTree(ped,"/Global/N_Ranged_A","Act/Anim/N_Ranged_A.act")
							--PedSetAITree(ped,"/Global/AI","Act/AI/AI.act")
							--PedDestroyWeapon(ped, 305)
							--GameSetPedStat(ped, 60, 1_07)
							nerdCombat = false
							--PedClearAllWeapons(ped)
						--elseif not PedIsValid(ped) or PedIsDead(ped) then
							--PedClearAllWeapons(ped)
						end
					elseif PedGetName(ped) == "N_Fatty" then
						local fattyGrab = math.random(750)
						if PedIsInCombat(ped) and not shouldIgnoreTarget(ped) and not PedIsPlaying(ped,"Hold_Idle") and not PedIsPlaying(ped,"Grapples",true) and not PedIsPlaying(ped,"MountIdle",true) and not PedMePlaying(ped,"Sprint",true) then
							if fattyGrab == 100 and DistanceBetweenPeds2D((PedGetTargetPed(ped)), ped) <= 1.5 then
								PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleAttempt","Act/Globals.act")
							end
						end
						if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
							if math.random(10) == 5 then
								PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/Mount/GrappleMoves/Headbutt","Act/Globals.act"},
									{"/Global/Actions/Grapples/Mount/GrappleMoves/FacePunch","Act/Globals.act"},
								})))
							end
						end	
						if PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true) then
							--PedFaceObjectNow(ped,PedGetGrappleTargetPed(ped), 3)
							--local grabTarget = PedGetGrappleTargetPed(ped)
							--LoadAnimationGroup("B_Striker")
							
							PedSetActionNode(ped,unpack(RandomTableElement({
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TakeDown","Act/Globals.act"},
									{"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/DirectionalPush/PushFwd/Give","Act/Globals.act"},
								})))
							--PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/TandemGrapple/TandemGrapple_ACTIVE/GIVE","act/anim/Player.act")
							--PedSetActionNode(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/GrappleStrikes/HitA","act/anim/Player.act")
						end

					end
				elseif PedGetFaction(ped) == 13 then 
					--TextPrintString("Found Player", 1, 1)
					if PedGetName(ped) == "N_Jimmy" then
						if WeaponEquipped(305) then
							PedSetDamageGivenMultiplier(ped,3,1.50)
							--PedOverrideStat(ped,31,150)
						elseif not WeaponEquipped(305) and not MissionActiveSpecific("4_B2") then
							PedSetDamageGivenMultiplier(ped,3,1.00)
							--PedOverrideStat(ped,31,100)
						end
						if MissionActiveSpecific("4_B2") then
							if WeaponEquipped(400) then
								PedSetDamageGivenMultiplier(ped,3,3.00)	
								--PedOverrideStat(ped,31,300)
							end
						end
					end
					if IsButtonBeingPressed(8,0) and not PedIsValid(PedGetGrappleTargetPed(gPlayer)) and not PedIsPlaying(ped,"Hold_Idle") and not PedMePlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) and not PedIsDead(PedGetTargetPed(ped)) then --and not PedIsInCombat(PedGetTargetPed(ped)) then
						if PedGetFaction(PedGetTargetPed(ped)) == 1 then
						--nerd
							if math.random(1,3) == 1 then
								SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_TAUNT_NERD",0,"supersize")
							end
						elseif PedGetFaction(PedGetTargetPed(ped)) == 2 then
						--jock
							if math.random(1,3) == 1 then
								SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_TAUNT_JOCK",0,"supersize")
							end
						elseif PedGetFaction(PedGetTargetPed(ped)) == 3 then
						-- DO 
							if math.random(1,3) == 1 then
								SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_TAUNT_DROPOUT",0,"supersize")
							end
						elseif PedGetFaction(PedGetTargetPed(ped)) == 4 then
						--Greaser
							if math.random(1,3) == 1 then
								SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_TAUNT_GREASER",0,"supersize")
							end
						elseif PedGetFaction(PedGetTargetPed(ped)) == 5 then
						--prep
							if math.random(1,3) == 1 then
								SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_TAUNT_PREP",0,"supersize")
							end
						elseif PedGetName(PedGetTargetPed(ped)) == "N_Pitbull" then
							SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_TAUNT_DOG",0,"supersize")
						end
					end
					if IsButtonBeingPressed(7,0) and not PedIsValid(PedGetGrappleTargetPed(gPlayer)) and not PedIsPlaying(ped,"Hold_Idle") and not PedMePlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) and not PedIsDead(PedGetTargetPed(ped)) then
						if not PedIsInCombat(gPlayer) then
							if PedGetName(PedGetTargetPed(ped)) == "N_Pedro" or PedGetName(PedGetTargetPed(ped)) == "N_Sheldon" then
								if math.random(1,3) == 1 then
									SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_GREET_GENERIC_BOY",0,"large")
								end
							end
						end
						if PedGetName(PedGetTargetPed(ped)) == "N_Pitbull" then
							SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_GREET_FRIENDLY_DOG",0,"supersize")
						end
					end
					if PedIsPlaying(ped,"/Global/HitTree/Standing/Melee/Unique/SACKED/Front",true) then
						local sackedJimmy = math.random(2)
						if not nutKick then
							cheapShot2 = GetTimer() + 3000
							if sackedJimmy == 1 then
								SoundPlayScriptedSpeechEvent(gPlayer,"M_5_04",30,"large",true)
							elseif sackedJimmy == 2 then
								SoundPlayScriptedSpeechEvent(gPlayer,"M_5_09",27,"large",true)
							end
							nutKick = true
						elseif nutKick and GetTimer() >= cheapShot2 then
							nutKick = false
						end
					end
				end
			end
			if PedIsPlaying(ped,"/Global/J_Damon/Offense/Medium/Grapples/GrapplesAttempt/TakeDown/PowerSwing", true) and PedGetTargetPed(ped) == gPlayer then--PedGetTargetPed(ped) == gPlayer then
				--PedApplyDamage(ped,45)
						--PedSetHealth(PedGetTargetPed(ped), (PedGetHealth(PedGetTargetPed(ped)) - 40))
				if not superThrow and PedGetNodeTime(ped) >= 2.0 then	
					if PedGetHealth(PedGetTargetPed(ped)) > PedGetMaxHealth(PedGetTargetPed(ped)) then
						PedSetMaxHealth(PedGetTargetPed(ped), PedGetHealth(PedGetTargetPed(ped)))
						PedSetHealth(PedGetTargetPed(ped), (PedGetHealth(PedGetTargetPed(ped)) - 40))
						PedSetMaxHealth(PedGetTargetPed(ped), 200)
						attackTimer = GetTimer() + 4000
						superThrow = true
					else
					
						PedSetHealth(PedGetTargetPed(ped), (PedGetHealth(PedGetTargetPed(ped)) - 40))
						--PedApplyDamage(gPlayer,40)
						attackTimer = GetTimer() + 4000
						superThrow = true
					end
				elseif superThrow and GetTimer() >= attackTimer then
					--PedSetHealth(PedGetTargetPed(ped), (PedGetHealth(PedGetTargetPed(ped)) - 40))
					superThrow = false
				end
			end
		--	if PedIsPlaying(ped,"/Global/J_Mascot/Offense/Short/Heavy/Stunners/Sack/SackFreq/GutKick_R",true) and PedGetTargetPed(ped) == gPlayer and PedIsHit(gPlayer) then
			--end
			if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/GIVE",true) and PedGetTargetPed(ped) == gPlayer then
				local lowBlow = math.random(3)
				if not nutCracker then	
					if PedGetNodeTime(ped) >= 0.4 then
						cheapShot = GetTimer() + 4000
						if lowBlow == 1 then
							SoundPlayScriptedSpeechEvent(gPlayer,"M_5_04",30,"large",true)
						--SoundPlayScriptedSpeechEvent(gPlayer,"PLAYER_JEER",0,"supersize")
						elseif lowBlow == 2 then
							SoundPlayScriptedSpeechEvent(gPlayer,"M_5_09",27,"large",true)
						else
							SoundPlayScriptedSpeechEvent(gPlayer,"M_5_04",42,"large",true)
						end
						nutCracker = true
					end
				elseif nutCracker and GetTimer() >= cheapShot then
					nutCracker = false
				end
			end
		end
end

AreaPedSpawn = function()
	if PedIsInAreaXYZ(gPlayer,-27.935499,-73.391403,0.000004, 60) then	--PedFindInAreaXYZ(-27.935499,-73.391403,0.000004, 100) and  not spawnMascot then
				--TextPrintString("Spawning Mascot...", 1, 1)
				daytime = ClockGet()
				relocateMascot = false
				--daytime = GetTimer()
				--TextPrintString(daytime, 1, 1)
				if not spawnMascot and not MissionActiveSpecific("4_B2") and not MissionActive() and not PedIsValid(gMascot) then
					--PedSetUniqueModelStatus(88,1)
					--mascotTime = GetTimer() + 360000
					--gMascot = PedCreateXYZ(88,unpack(RandomTableElement({
						--											{-12,-100,1},
							--										{-10,-45,1},
								--								})))
					gMascot = PedCreateXYZ(88,math.random(-12,-10),math.random(-100,-45),1)
					Mx, My, Mz = PedGetPosXYZ(gMascot)
					PedFaceXYZ(gMascot,Mx - 1, My, Mz)
					LoadAnimationGroup("NPC_Mascot")
					if PedGetMaxHealth(gMascot) >= 650 then
						PedSetHealth(gMascot, PedGetMaxHealth(gMascot) - 200)
						PedSetMaxHealth(gMascot, PedGetHealth(gMascot))
					end
					--deSpawnPed = false
					spawnMascot = true
				elseif not MissionActive() and not PedIsValid(gMascot) and PedIsDead(gMascot) and spawnMascot then
					--PedSetUniqueModelStatus(88,-1)
					if not mascotDead then
						mascotTime = GetTimer() + 180000
						mascotDead = true
					elseif GetTimer() >= mascotTime and mascotDead then
						mascotDead = false
						spawnMascot = false
					end
				elseif PedIsValid(gMascot) and PedIsInAreaXYZ(gMascot,-27.935499,-73.391403,0.000004, 60) then
					despawnMascot = false
						if not PedIsInCombat(gMascot) and not PedIsHit(gMascot) and not PedIsDead(gMascot) and PedGetHealth(gMascot) > 0 and not stopMascot then
							if not mascotDance and not mascotMove then
								PedSetActionNode(gMascot, "/Global/J_Mascot/Offense/Dance/Dancing", "Act/Anim/J_Mascot.act")
								--dancingMascot = GetTimer() + 1000
								mascotDance = true
							elseif mascotDance and not PedIsPlaying(gMascot, "/Global/J_Mascot/Offense/Dance/Dancing", true) then  --GetTimer() >= dancingMascot then
								mascotDance = false
							end	
						end

				end
				if  daytime >= 19 or daytime <= 7 or MissionActive() then
						--TextPrintString("It's nighttime...", 1, 1)
					if PedIsValid(gMascot) and not PedIsDead(gMascot) and not despawnMascot and not PedIsInCombat(gMascot) then
						--TextPrintString("Despawning Mascot...", 1, 1)
						PedSetPosXYZ(gMascot,-700,504,1.99)
						--PedMakeAmbient(gMascot)
						despawnMascot = true
					end
				end
				if PedIsHit(gMascot) and not stopMascot or PedIsInCombat(gMascot) and not stopMascot or PedInConversation(gMascot) and not stopMascot then
					PedMakeAmbient(gMascot)
					--PedMoveToXYZ(gMascot,0,x,y,z)
					stopMascot = true
				end
			
			elseif not PedIsInAreaXYZ(gPlayer,-27.935499,-73.391403,0.000004, 60) then
				--if MissionActive() then
					--if PedIsValid(gMascot) then
						--PedSetPosXYZ(gMascot,-772,-125,7.3)
						--PedSetHealth(gMascot,0)
						--deSpawnPed = true
				--end
				--if PedIsValid(gMascot) and not stopMascot then
					--PedMakeAmbient(gMascot)
					--stopMascot = true
				--end
				if not PedIsValid(gMascot) then
					spawnMascot = false
					stopMascot = false
				end
				if not MissionActive() and not relocateMascot and PedIsValid(gMascot) and not PedIsDead(gMascot) and not PedIsInCombat(gMascot) then
					PedSetPosXYZ(gMascot,math.random(-12,-10),math.random(-100,-45),1)
					Mx, My, Mz = PedGetPosXYZ(gMascot)
					PedFaceXYZ(gMascot,Mx - 1, My, Mz)
					--PedFaceXYZ(gMascot,Mx, My + 1, Mz)
					--TextPrintString("Despawning Mascot...", 1, 1)
					--PedSetPosXYZ(gMascot,-772,-125,7.3)
					--PedSetHealth(gMascot,0)
					--despawnMascot = true
					if PedGetHealth(gMascot) < PedGetMaxHealth(gMascot) and PedIsValid(gMascot) and not PedIsDead(gMascot) and not PedIsInCombat(gMascot) and not MissionActive() then
						PedSetHealth(gMascot, PedGetMaxHealth(gMascot))
						--PedSetPosXYZ(gMascot,-772,-125,7.3)
					--	PedSetHealth(gMascot,0)
						--deSpawnPed = true
					end
					PedMakeAmbient(gMascot)
					relocateMascot = true
					stopMascot = false
				end
			end
			if AreaGetVisible() == 8 and not MissionActive() then	--PedFindInAreaXYZ(-27.935499,-73.391403,0.000004, 100) and  not spawnMascot then
				--TextPrintString("Spawning Mascot...", 1, 1)
				relocateJanitor = false
				if not spawnJanitor and not PedIsValid(gJanitor) then
					janitorTime = GetTimer() + 30000
					gJanitor = PedCreateXYZ(56,unpack(RandomTableElement({
						{-772,-148,7.39},
						{-738,-45.9,9.3},
						})))
					--PedWander(gJanitor)
					--PedMakeAmbient(gJanitor)
					PedSetFaction(gJanitor,0) 
					PedClearAllWeapons(gJanitor)
					AddBlipForChar(gJanitor, 0, 2 , 3)
					spawnJanitor = true
				elseif PedIsValid(gJanitor) then
					PedCreateStimulus(gPlayer, gJanitor, 68)
					--if not PedIsInCombat(gJanitor) then
					if not janitorMoving then --and not PedIsInCombat(gJanitor) then
						--TextPrintString("Janitor is Moving", 5, 1)
						local x,y,z = unpack(RandomTableElement(basePositions))
						janitorMove = GetTimer() + 30000
						janitorMoving = true
						if janitorMoving then
							PedMoveToXYZ(gJanitor,0,x,y,z)
							--PedSetTetherToXYZ(gJanitor,x,y,z)
							--janitorMove = GetTimer() + 20000
							--janitorMoving = true
						end
					elseif GetTimer() >= janitorMove then
						janitorMoving = false
					end
					--end
				elseif not MissionActive() and not PedIsValid(gJanitor) and PedIsDead(gJanitor) and spawnJanitor then
					if not janitorDead then
						janitorTime = GetTimer() + 120000
						janitorDead = true
					elseif GetTimer() >= janitorTime and janitorDead then
						spawnJanitor = false
						janitorDead = false
					end
				end
				if relocatePrincipal and PedIsValid(gPrincipal) and not PedIsDead(gPrincipal) then
					PedSetPosXYZ(gPrincipal, -704, 205, 31)
					relocatePrincipal = false
				end
			
			else
				if PedIsInCombat(gJanitor) then
					chasingJanitor = GetTimer() + 1250
				end
				if PedIsValid(gJanitor) and GetTimer() >= chasingJanitor and not PedIsDead(gJanitor) and not PedIsInCombat(gJanitor) and not relocateJanitor then
					local x,y,z = unpack(RandomTableElement(basePositions))
					PedSetPosXYZ(gJanitor, x,y,z)
					if PedGetHealth(gJanitor) < PedGetMaxHealth(gJanitor) and PedIsValid(gJanitor) and not PedIsDead(gJanitor) and not PedIsInCombat(gJanitor) and not MissionActive() then
						PedSetHealth(gJanitor, PedGetMaxHealth(gJanitor))
					end
					relocateJanitor = true
				end
			end
			if AreaGetVisible() == 5 and not MissionActive() then
				--outoffOffice = false
				relocatePrincipal = false
				if not spawnPrincipal and not PedIsValid(gPrincipal) then
					--principalTime = GetTimer() + 30000
					gPrincipal = PedCreateXYZ(65, -704, 205, 31)
					Px, Py, Pz = PedGetPosXYZ(gPrincipal)
					PedFaceXYZ(gPrincipal,Px + 1, Py, Pz)
					PedSetFaction(gPrincipal,0) 
					AddBlipForChar(gPrincipal, 0, 2 , 3)
					spawnPrincipal = true
				elseif not MissionActive() and not PedIsValid(gPrincipal) or PedIsDead(gPrincipal) and spawnPrincipal then
					if not principalDead then
						principalTime = GetTimer() + 120000
						principalDead = true
					elseif GetTimer() >= principalTime and principalDead then
						spawnPrincipal = false
						principalDead = false
					end
				end
				if outoffOffice then
					SoundPlayScriptedSpeechEvent(gPrincipal,"GREET",0,"supersize",true)
					outoffOffice = false
				end
			else
			outoffOffice = true
				if PedIsInCombat(gPrincipal) then
					chasingPrincipal = GetTimer() + 1250
				end
				if PedIsValid(gPrincipal) and not PedIsDead(gPrincipal) and GetTimer() >= chasingPrincipal and not PedIsInCombat(gPrincipal) and AreaGetVisible() ~= 8 and outoffOffice and not relocatePrincipal then
					PedMakeAmbient(gPrincipal)
					PedDelete(gPrincipal)
					spawnPrincipal = false
					--PedSetPosXYZ(gPrincipal, -770,-64,12.37)
					--relocatePrincipal = true
					--Px, Py, Pz = PedGetPosXYZ(gPrincipal)
					--PedFaceXYZ(gPrincipal,Px + 1, Py, Pz)
					--PedSetHealth(gPrincipal, PedGetMaxHealth(gPrincipal))
				end
			end
			if AreaGetVisible() == 32 then
				local Hour, Minute = ClockGet() 
				local next = next
				local availablePreps = table.getn(preps)
				--TextPrintString(availablePreps, 1, 1)
				if not MissionActiveSpecific("2_08") and not MissionActiveSpecific("6_03") then
					--local chosenPrep = math.random(table.getn(preps))
					chosenPrep = math.random(table.getn(preps))
					summonPrep = function(xm, ym, zm)	--adapted from RBS ID
						chosenPrep = math.random(table.getn(preps))
						prep = PedCreateXYZ(preps[chosenPrep], x, y, z)
						PedMakeAmbient(prep)
						table.remove(preps, chosenPrep)
						--table.insert(spawnedPreps,chosenPrep)
						PedSetPOI(prep, POI._2_08_FIRSTFLOORHANG, true)
						PedSetPOI(prep, POI._2_08_SECONDFLOORHANG, true)
						PedSetPOI(prep, POI._2_08_THIRDFLOORHANG, true)
						PedMoveToXYZ(prep, 0, xm, ym, zm)
						if PedGetName(prep) == "N_Darby" then
							hhDarby = prep
						elseif PedGetName(prep) == "N_Bif" then
							hhBif = prep
						elseif PedGetName(prep) == "N_Pinky" then
							hhPinky = prep
						end
					end
					if not prepInteracting and availablePreps > 1 and next(preps) ~= nil and spawnPreps > 1 then
						DATLoad("2_08.DAT", 2)
						LoadAnimationGroup("NPC_Chat_1")
						LoadAnimationGroup("Hang_Talking")
						
						hhPrep1 = PedCreateXYZ(preps[chosenPrep], -534.539001, 132.809006, 46.225899)
						PedFaceXYZ(hhPrep1, -535.737000, 131.042007, 46.186001)
						--PedSetPOI(hhPrep1, POI._2_08_FIRSTFLOORHANG, true)
						table.remove(preps, chosenPrep)
						--table.insert(spawnedPreps,chosenPrep)
						
						chosenPrep2 = math.random(table.getn(preps))
						hhPrep2 = PedCreateXYZ(preps[chosenPrep2], -535.737000, 131.042007, 46.186001)
						PedFaceXYZ(hhPrep2, -534.539001, 132.809006, 46.225899)
						--PedSetPOI(hhPrep2, POI._2_08_FIRSTFLOORHANG, true)
						table.remove(preps, chosenPrep2)
						--table.insert(spawnedPreps,chosenPrep2)
						
						--PedMakeAmbient(hhPrep1)
						--PedMakeAmbient(hhPrep2)
						--PedSetActionNode(hhPrep1, "/Global/2_08Conv/Idle/PlayerIdle", "Act/Conv/2_08.act")
						--PedSetActionNode(hhPrep2, "/Global/2_08Conv/Idle/PlayerIdle", "Act/Conv/2_08.act")
						PedSetPOI(hhPrep1, POI._2_08_FIRSTFLOORHANG, true)
						PedSetPOI(hhPrep2, POI._2_08_FIRSTFLOORHANG, true)
						PedMakeAmbient(hhPrep1)
						PedMakeAmbient(hhPrep2)
						spawnPreps = spawnPreps - 2
						if PedGetName(hhPrep1) == "N_Darby" then
							hhDarby = hhPrep1
						elseif PedGetName(hhPrep2) == "N_Darby" then
							hhDarby = hhPrep2
						end
						if PedGetName(hhPrep1) == "N_Bif" then
							hhBif = hhPrep1
						elseif PedGetName(hhPrep2) == "N_Bif" then
							hhBif = hhPrep2
						end
						if PedGetName(hhPrep1) == "N_Pinky" then
							hhPinky = hhPrep1
						elseif PedGetName(hhPrep2) == "N_Pinky" then
							hhPinky = hhPrep2
						end
						prepInteracting = true
					end
					if prepInteracting then
						if not prepTalk1 and PedIsInAreaXYZ(gPlayer,-535.335022, 132.147995, 46.251999, 20) and availablePreps > 1 and next(preps) ~= nil and spawnPreps > 1 then -- PlayerIsInAreaObject(hhPrep1, 2, 6, 0) then
							if not PedIsValid(hhPrep1) and not PedIsValid(hhPrep2) and next(preps) ~= nil then
								DATLoad("2_08.DAT", 2)
								LoadAnimationGroup("NPC_Chat_1")
								LoadAnimationGroup("Hang_Talking")
								hhPrep1 = PedCreateXYZ(preps[chosenPrep], -534.539001, 132.809006, 46.225899)
								PedFaceXYZ(hhPrep1, -535.737000, 131.042007, 46.186001)
								--PedSetPOI(hhPrep1, POI._2_08_FIRSTFLOORHANG, true)
								table.remove(preps, chosenPrep)
							--	table.insert(spawnedPreps,chosenPrep)
								
								chosenPrep2 = math.random(table.getn(preps))
								hhPrep2 = PedCreateXYZ(preps[chosenPrep2], -535.737000, 131.042007, 46.186001)
								PedFaceXYZ(hhPrep2, -534.539001, 132.809006, 46.225899)
								--PedSetPOI(hhPrep2, POI._2_08_FIRSTFLOORHANG, true)
								table.remove(preps, chosenPrep2)
								--table.insert(spawnedPreps,chosenPrep2)
								
								PedSetPOI(hhPrep1, POI._2_08_FIRSTFLOORHANG, true)
								PedSetPOI(hhPrep2, POI._2_08_FIRSTFLOORHANG, true)
								PedMakeAmbient(hhPrep1)
								PedMakeAmbient(hhPrep2)
								
								if PedGetName(hhPrep1) == "N_Darby" then
									hhDarby = hhPrep1
								elseif PedGetName(hhPrep2) == "N_Darby" then
									hhDarby = hhPrep2
								end
								if PedGetName(hhPrep1) == "N_Bif" then
									hhBif = hhPrep1
								elseif PedGetName(hhPrep2) == "N_Bif" then
									hhBif = hhPrep2
								end
								if PedGetName(hhPrep1) == "N_Pinky" then
									hhPinky = hhPrep1
								elseif PedGetName(hhPrep2) == "N_Pinky" then
									hhPinky = hhPrep2
								end
								
								--PedSetActionNode(hhPrep1, "/Global/2_08Conv/Interruptable/TalkAnims", "Act/Conv/2_08.act")
								--PedSetActionNode(hhPrep2, "/Global/2_08Conv/Interruptable/ListenAnims", "Act/Conv/2_08.act")
								spawnPreps = spawnPreps - 2
								--prepInteracting = true
								prepTalk1 = true
							end
						end
						if prepTalk1 and not PedIsInAreaXYZ(gPlayer,-535.335022, 132.147995, 46.251999, 22) then
							--if PedIsValid(hhPrep1) or PedIsValid(hhPrep2) then
								--PedMakeAmbient(hhPrep1)
								--PedMakeAmbient(hhPrep2)
							--end
							--spawnPreps = spawnPreps + 2
							prepTalk1 = false
						end
						if not prepTalk2 and PedIsInAreaXYZ(gPlayer,-526.343994, 136.117004, 50.964199, 8) and availablePreps > 1 and next(preps) ~= nil and spawnPreps > 1 then
							--if not PedIsValid(hhPrep3) and not PedIsValid(hhPrep4) then
							DATLoad("2_08.DAT", 2)
							LoadAnimationGroup("NPC_Chat_1")
							LoadAnimationGroup("Hang_Talking")
							chosenPrep3 = math.random(table.getn(preps))
							hhPrep3 = PedCreateXYZ(preps[chosenPrep3], -525.809998, 135.246002, 50.769199)
							PedFaceXYZ(hhPrep3, -526.198975, 136.494003, 50.759201)
							--PedSetPOI(hhPrep3, POI._2_08_SECONDFLOORHANG, true)
							table.remove(preps, chosenPrep3)
							--table.insert(spawnedPreps,chosenPrep3)
							
							chosenPrep4 = math.random(table.getn(preps))
							hhPrep4 = PedCreateXYZ(preps[chosenPrep4], -526.198975, 136.494003, 50.759201)
							PedFaceXYZ(hhPrep4, -525.809998, 135.246002, 50.769199)
							--PedSetPOI(hhPrep4, POI._2_08_SECONDFLOORHANG, true)
							table.remove(preps, chosenPrep4)
						--	table.insert(spawnedPreps,chosenPrep4)
							PedSetPOI(hhPrep3, POI._2_08_SECONDFLOORHANG, true)
							PedSetPOI(hhPrep3, POI._2_08_SECONDFLOORHANG, true)
							PedMakeAmbient(hhPrep3)
							PedMakeAmbient(hhPrep4)
							if PedGetName(hhPrep3) == "N_Darby" then
								hhDarby = hhPrep3
							elseif PedGetName(hhPrep4) == "N_Darby" then
								hhDarby = hhPrep4
							end
							if PedGetName(hhPrep3) == "N_Bif" then
									hhBif = hhPrep3
							elseif PedGetName(hhPrep4) == "N_Bif" then
								hhBif = hhPrep4
							end
							if PedGetName(hhPrep3) == "N_Pinky" then
								hhPinky = hhPrep3
							elseif PedGetName(hhPrep4) == "N_Pinky" then
								hhPinky = hhPrep4
							end
							--PedSetActionNode(hhPrep3, "/Global/2_08Conv/Interruptable/TalkAnims", "Act/Conv/2_08.act")
							--PedSetActionNode(hhPrep4, "/Global/2_08Conv/Interruptable/ListenAnims", "Act/Conv/2_08.act")
							spawnPreps = spawnPreps - 2
							prepTalk2 = true
							--end
						
						end
						if prepTalk1 and not PedIsInAreaXYZ(gPlayer,-526.343994, 136.117004, 50.964199, 20) then
							--if PedIsValid(hhPrep1) or PedIsValid(hhPrep2) then
								--PedMakeAmbient(hhPrep1)
								--PedMakeAmbient(hhPrep2)
							--end
							--spawnPreps = spawnPreps + 2
							prepTalk2 = false
						end
						
					end
					if Hour >= 7 and Hour < 19 then
						local ChooseHHSpawn, ChooseHHRoom, ChooseHHFloor = math.random(3), math.random(9), math.random(3)
						if ChooseHHSpawn == 1 then
							x, y, z = Coord.HarringtonHouse.InDoor[2], Coord.HarringtonHouse.InDoor[3], Coord.HarringtonHouse.InDoor[4]
						elseif ChooseHHSpawn == 2 then
							x, y, z = Coord.HarringtonHouse.Door1[2], Coord.HarringtonHouse.Door1[3], Coord.HarringtonHouse.Door1[4]
						elseif ChooseHHSpawn == 3 then
							x, y, z = Coord.HarringtonHouse.Door2[2], Coord.HarringtonHouse.Door2[3], Coord.HarringtonHouse.Door2[4]
						--elseif ChooseHHSpawn == 4 then
							--x, y, z = Coord.HarringtonHouse.Door3[2], Coord.HarringtonHouse.Door3[3], Coord.HarringtonHouse.Door3[4]
						end
						if ChooseHHFloor == 1 and ChooseHHRoom == 1 then
							Z = 46.15
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room1_1[1], Coord.HarringtonHouse.Room1_1[2], Coord.HarringtonHouse.Room1_1[3], Coord.HarringtonHouse.Room1_1[4]
						elseif ChooseHHFloor == 1 and ChooseHHRoom == 2 then
							Z = 46.15
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room1_2[1], Coord.HarringtonHouse.Room1_2[2], Coord.HarringtonHouse.Room1_2[3], Coord.HarringtonHouse.Room1_2[4]
						elseif ChooseHHFloor == 2 and ChooseHHRoom == 1 then
							Z = 50.72
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room2_1[1], Coord.HarringtonHouse.Room2_1[2], Coord.HarringtonHouse.Room2_1[3], Coord.HarringtonHouse.Room2_1[4]
						elseif ChooseHHFloor == 2 and ChooseHHRoom == 2 then
							Z = 50.72
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room2_2[1], Coord.HarringtonHouse.Room2_2[2], Coord.HarringtonHouse.Room2_2[3], Coord.HarringtonHouse.Room2_2[4]
						elseif ChooseHHFloor == 2 and ChooseHHRoom == 3 then
							Z = 50.72
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room2_3[1], Coord.HarringtonHouse.Room2_3[2], Coord.HarringtonHouse.Room2_3[3], Coord.HarringtonHouse.Room2_3[4]
						elseif ChooseHHFloor == 3 and ChooseHHRoom == 1 then
							Z = 55.65
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room3_1[1], Coord.HarringtonHouse.Room3_1[2], Coord.HarringtonHouse.Room3_1[3], Coord.HarringtonHouse.Room3_1[4]
						elseif ChooseHHFloor == 3 and ChooseHHRoom == 2 then
							Z = 55.65
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room3_2[1], Coord.HarringtonHouse.Room3_2[2], Coord.HarringtonHouse.Room3_2[3], Coord.HarringtonHouse.Room3_2[4]
						elseif ChooseHHFloor == 3 and ChooseHHRoom == 3 then
							Z = 55.65
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room3_3[1], Coord.HarringtonHouse.Room3_3[2], Coord.HarringtonHouse.Room3_3[3], Coord.HarringtonHouse.Room3_3[4]
						elseif ChooseHHFloor == 3 and ChooseHHRoom == 4 then
							Z = 57.12
							x1, y1, x2, y2 = Coord.HarringtonHouse.Room3_4[1], Coord.HarringtonHouse.Room3_4[2], Coord.HarringtonHouse.Room3_4[3], Coord.HarringtonHouse.Room3_4[4]
						end
						if spawnPreps > 0 and availablePreps > 0 and next(preps) ~= nil then
							if GetTimer() >= hhspawnInterval then	
								if math.random(300) >= 297 then
									summonPrep(math.random(x2, x1), math.random(y2, y1), Z)
									spawnPreps = spawnPreps - 1
									hhspawnInterval = GetTimer() + 5000
								end
							end
						elseif spawnPreps < 1 and GetTimer() >= hhspawnTimer and not PedIsInCombat(gPlayer) then
							hhspawnTimer, spawnPreps = GetTimer() + 50000, 9
							--spawnPreps = 8
						end
					end
					if availablePreps < 1 or next(preps) == nil then
						preps = {30, 31, 34, 40, 35, 32, 33, 37, 38}
						if PedIsValid(hhDarby) then
							preps = {30, 31, 34, 40, 35, 32, 33, 38}
						elseif PedIsValid(hhBif) then
							preps = {30, 31, 34, 40, 35, 32, 37, 38}
						elseif PedIsValid(hhPinky) then
							preps = {30, 31, 34, 40, 35, 32, 33, 37}
						end
						if PedIsValid(hhDarby) and PedIsValid(hhBif) then
							preps = {30, 31, 34, 40, 35, 32, 38}
						end
						if PedIsValid(hhPinky) and PedIsValid(hhBif) then
							preps = {30, 31, 34, 40, 35, 32, 37}
						end
						if PedIsValid(hhDarby) and PedIsValid(hhPinky) then
							preps = {30, 31, 34, 40, 35, 32, 33}
						end
						if PedIsValid(hhDarby) and PedIsValid(hhPinky) and PedIsValid(hhBif) then
							preps = {30, 31, 34, 40, 35, 32}
						end
						
						--local checkPrep = math.random(table.getn(preps))
						--local checkSpawn = math.random(table.getn(spawnedPreps))
						for _, value in pairs(preps) do
							if PedIsValid(prep) and PedIsModel(prep, preps[value]) or PedIsValid(hhPrep1) and  PedIsModel(hhPrep1, preps[value]) or PedIsValid(hhPrep2) and PedIsModel(hhPrep2, preps[value]) then--or PedIsModel(ped, value) then
								table.remove(preps, preps[value])
							end
						end
					end
					--local modelPrep, modelPrep2, modelPrep3 = PedIsModel(prep), PedIsModel(hhPrep1), PedIsModel(hhPrep2)
				end
			else
				prepInteracting = false
				prepTalk1 = false
				prepTalk2 = false
				if PedIsValid(hhDarby) then
					PedDelete(hhDarby)
				end
				if PedIsValid(hhPrep1) or PedIsValid(hhPrep2) or PedIsValid(hhPrep3) or PedIsValid(hhPrep4) then
					PedMakeAmbient(hhPrep1) PedMakeAmbient(hhPrep2) PedMakeAmbient(hhPrep3) PedMakeAmbient(hhPrep4) 
					PedDelete(hhPrep1) PedDelete(hhPrep2) PedDelete(hhPrep3) PedDelete(hhPrep4)
				end
			end
			--if GetCutsceneRunning() ~= 0 then --and not cutscenePrincipal then
					--PedSetPosXYZ(gPrincipal, -772,-85.4,7.4)
					--cutscenePrincipal = true
			--elseif PedIsValid(gPrincipal) and GetCutsceneRunning() == 0 then
				--cutscenePrincipal = true
			--end
			if AreaGetVisible() == 14 then
				daytime = ClockGet()
				if  daytime >= 21 or daytime < 9 then
					PedSetUniqueModelStatus(66,-1)
					PedSetUniqueModelStatus(69,-1)
					PedSetUniqueModelStatus(225, 1)
					PedSetUniqueModelStatus(226, 1)
				else
					PedSetUniqueModelStatus(66, 1)
					PedSetUniqueModelStatus(69, 1)
					PedSetUniqueModelStatus(225,-1)
					PedSetUniqueModelStatus(226,-1)
				end
			else
				PedSetUniqueModelStatus(66, 1)
				PedSetUniqueModelStatus(69, 1)
				PedSetUniqueModelStatus(225,-1)
				PedSetUniqueModelStatus(226,-1)
			end
			if MissionActiveSpecific("6_03") then
				PedSetUniqueModelStatus(37,-1)
				PedSetUniqueModelStatus(23,-1)
				PedSetUniqueModelStatus(19,-1)
				PedSetUniqueModelStatus(10,-1)
			elseif MissionActiveSpecific("3_06") then
				PedSetUniqueModelStatus(23,-1)
			elseif not MissionActiveSpecific("6_03") and not MissionActiveSpecific("3_06") then
				PedSetUniqueModelStatus(37, 1)
				PedSetUniqueModelStatus(23, 1)
				PedSetUniqueModelStatus(19, 1)
				PedSetUniqueModelStatus(10, 1)
				PedSetUniqueModelStatus(91, 1)
				PedSetUniqueModelStatus(121, 1)
				PedSetUniqueModelStatus(130, 1)
				PedSetUniqueModelStatus(134, 1)
			end
			if MissionActiveSpecific("1_11x1") then
				PedSetUniqueModelStatus(75,-1)
				--PedSetUniqueModelStatus(88, 1)
				--PedSetUniqueModelStatus(186, 1)
				--PedSetUniqueModelStatus(256, 1)
				--PedSetUniqueModelStatus(257, 1)
				--PedSetUniqueModelStatus(74, -1)
				--PedSetUniqueModelStatus(5, -1)
				--PedSetUniqueModelStatus(137, -1)
			elseif not MissionActiveSpecific("1_11x1") then
				PedSetUniqueModelStatus(75, 1)
				--PedSetUniqueModelStatus(88,-1)
				--PedSetUniqueModelStatus(186, -1)
				--PedSetUniqueModelStatus(256, -1)
				--PedSetUniqueModelStatus(257, -1)
				--PedSetUniqueModelStatus(74, 1)
				--PedSetUniqueModelStatus(5, 1)
				--PedSetUniqueModelStatus(137, 1)
			end
end


PedIsBlocking = function(ped)
	--if not PedMePlaying(ped,"Block",true) or not PedMePlaying(ped,"0_BLOCK_0",true) then
	if not PedMePlaying(ped,"Block",true) or PedMePlaying(ped,"0_BLOCK_0",true) then
		return false
	end
		return true
end

HitIsPlaying = function(ped,node)
	return PedGetHealth(ped) > 0 and PedIsHit(ped,2,200) and PedIsValid(PedGetWhoHitMeLast(ped)) and PedIsPlaying(PedGetWhoHitMeLast(ped),node,true) and not PedMePlaying(ped,"Cars",true) and isHitedPed[ped] == nil
end

GrappleIsPlaying = function(ped,node)
	return PedGetHealth(ped) > 0 and PedIsValid(ped) and PedIsPlaying(ped,node,true) and not PedMePlaying(ped,"Cars",true) and isHitedPed[ped] == nil
end

GrappleAnimationPlaying = function(ped)
	for _,node in ipairs({
			"MountReversalPunches",
			"BearHug",
			"BodySlam",
			"PowerBomb",
			"BackBreaker",
			"Sprawl",
			"PowerSwing",
		}) do
	--if PedMePlaying(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BackBreaker/Give",true) or PedMePlaying(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/BodySlam",true) or PedMePlaying(ped,"/Global/Actions/Grapples/Front/Grapples/GrappleMoves/PowerBomb/GIVE",true) or PedMePlaying(ped,"/Global/Actions/Grapples/GrappleReversals/StandingReversals/Sprawl/GIVE",true) or PedMePlaying(ped,"/Global/J_Damon/Offense/Medium/Grapples/GrapplesAttempt/TakeDown/PowerSwing",true) or PedMePlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE", true) or PedMePlaying(ped,"/Global/J_Striker_A/Offense/Medium/Grapples/GrapplesAttempt", true) then
		if PedMePlaying(ped,node,true) or PedIsPlaying(ped,node,true) or  PedIsPlaying(ped,"/Global/J_Striker_A/Offense/Medium/Grapples/GrapplesAttempt", true) or PedMePlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true) then
			return true
		else
			return false
		end
	end
end

shouldIgnoreTarget = function(victim) -- adapted from Derpy/DaBoss
	if PedMePlaying(victim,"/Global/Player/Social_Actions/HarassMoves/Humiliations",true) then
		-- don't interupt humiliations.
		return true
	end
	if isPedBeingGrappled(victim) then
		-- another enemy is already grappling the target.
		return true
	end
	if PedMePlaying(victim,"PedPropActions",true) and PedMePlaying(victim,"Stealth",true) then
		-- don't do an attack, let the normal AI pull the target out or lose them.
		return true
	end
	if PedIsDead(victim) then
		-- they're already dead, lay off.
		return true
	end
	if PedMePlaying(victim,"HitTree") then
		if PedGetHealth(victim) <= 0 then
			-- they're already dying.
			return true
		end
		for _,node in ipairs({
			"BellyDown",
			"BellyUp",
			"Breaker",
		}) do
			if PedMePlaying(victim,node,true) then
				-- they're playing an interuptable hit-node, don't ignore.
				return false
			end
		end
		-- they're being hit already, wait.
		return true
	end
	return false
end

isPedBeingGrappled = function(ped)
	local target = PedGetGrappleTargetPed(ped)
	return PedIsValid(target) and (
		--PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/MountIdle/GIVE",true)
		--or (PedMePlaying(ped,"Hold_Idle") and PedMePlaying(ped,"GIVE",true))
		PedMePlaying(ped,"RCV",true)
		or PedMePlaying(target,"GIVE",true)
	)
end
--isPedOnGround = function(ped)
	--if not PedIsValid(PedGetGrappleTargetPed(ped)) then
		--if PedMePlaying(ped,"HitTree",true) and (PedMePlaying(ped,"BellyUp",true) or PedMePlaying(ped,"BellyDown",true)) then
			--return true
		--end
		--if PedIsPlaying(ped,"/Global/Actions/Grapples/Mount/GrappleMoves/KneeDrop/RCV",true) then
		--	return true
		--end
	--end
	--return false
--end

--SpawnMascot = function
	--gMascot = PedCreateXYZ(88,-27.935499,-73.391403,0.000004)
--end

function Interiors()
	  --while true do
		  local x,y = 276.4747925,-137.654892
		  local r1 = x + 1
		  local r2 = y + 1
		  local r3 = x - 1
		  local r4 = y - 1
		  local one,two = -502.8657837,329.8096619
		  local r5 = one + 1
		  local r6 = two + 1
		  local r7 = one - 1
		  local r8 = two - 1
		  local three,four = -696.3,67.0
		  local r9 = three + 1
		  local r10 = four + 1
		  local r11 = three - 1
		  local r12 = four - 1
		  local five,six = 48.0,-134.1
		  local r13 = five + 1
		  local r14 = six + 1
		  local r15 = five - 1
		  local r16 = six - 1
		  local seven,eight = 583.6,-472.0
		  local r17 = seven + 1
		  local r18 = eight + 1
		  local r19 = seven - 1
		  local r20 = eight - 1
		  local nine,ten = -629.5171509,-280.8648682
		  local r21 = nine + 1
		  local r22 = ten + 1
		  local r23 = nine - 1
		  local r24 = ten - 1
		  local eleven,twelve = -701.2000122,216.6999969
		  local r25 = eleven + 1
		  local r26 = twelve + 1
		  local r27 = eleven - 1
		  local r28 = twelve - 1
		  local thirteen,fourteen = -497.917,309.401
		  local r29 = thirteen + 1
		  local r30 = fourteen + 1
		  local r31 = thirteen - 1
		  local r32 = fourteen - 1
				if PedInRectangle(gPlayer,r1,r2,r3,r4) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
					TextPrintString("Press ~TAG_COMBO3~ to enter the boys dorm from the back",1,2)
				elseif PedInRectangle(gPlayer,r1,r2,r3,r4) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
					AreaTransitionXYZ(14,-502.8657837,329.8096619,31)
				elseif PedInRectangle(gPlayer,r5,r6,r7,r8) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
					TextPrintString("Press ~TAG_COMBO3~ to exit the boys dorm to the back",1,2)
				elseif PedInRectangle(gPlayer,r5,r6,r7,r8) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
					AreaTransitionXYZ(0,276.4747925,-137.654892,6)
				elseif PedInRectangle(gPlayer,r21,r22,r23,r24) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
					TextPrintString("Press ~TAG_COMBO3~ to enter the principal's office",1,2)
				elseif PedInRectangle(gPlayer,r21,r22,r23,r24) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) and not PedIsValid(PedGetGrappleTargetPed(gPlayer)) then
					AreaTransitionXYZ(5,-701.2000122,216.6999969,31)
					PedFaceXYZ(gPlayer,-701.2000122,216.6999969 - 1,31)
					CameraReturnToPlayer()
					if PedIsValid(gPrincipal) and not PedIsDead(gPrincipal) and not PedIsInCombat(gPrincipal) then
						PedSetPosXYZ(gPrincipal, -704, 205, 31)
						Px, Py, Pz = PedGetPosXYZ(gPrincipal)
						PedFaceXYZ(gPrincipal,Px + 1, Py, Pz)
						PedSetHealth(gPrincipal, PedGetMaxHealth(gPrincipal))
						--returnPrincipal = false--relocatePrincipal = false
						--returnPrincipal = true
					end
					if PedIsInCombat(gPrincipal) and PedGetTargetPed(gPrincipal) == gPlayer then
						PedSetPosXYZ(gPrincipal, -701.2000122 + 1,216.6999969,31)
						PedAttackPlayer(gPrincipal, gPlayer, 3)
					end
				elseif PedInRectangle(gPlayer,r25,r26,r27,r28) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
					TextPrintString("Press ~TAG_COMBO3~ to exit the principal's office",1,2)
				elseif PedInRectangle(gPlayer,r25,r26,r27,r28) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) and not PedIsValid(PedGetGrappleTargetPed(gPlayer))  then
					AreaTransitionXYZ(2,-629.5171509,-280.8648682,5)
					PedFaceXYZ(gPlayer,-629.5171509,-280.8648682 - 1,5)
					CameraReturnToPlayer()
					if PedIsInCombat(gPrincipal) and PedGetTargetPed(gPrincipal) == gPlayer then
						PedSetPosXYZ(gPrincipal, -629.5171509 + 1,-280.8648682,5)
						PedAttackPlayer(gPrincipal, gPlayer, 3)
					end
				end
				if IsMissionCompleated("2_08") then
					AreaSetDoorLocked(TRIGGER._DOOR_PREPHOUSE_FOYER, false)
					AreaSetDoorLocked(TRIGGER._DT_PREPTOMAIN, false)
					AreaSetDoorLocked(TRIGGER._DOOR_PREPHOUSE_STAIRS, false)
					AreaSetDoorLocked(TRIGGER._DT_TSCHOOL_PREPPYL, false)
					AreaSetDoorLocked(TRIGGER._DT_TSCHOOL_PREPPYL, false)
				end
				if IsMissionCompleated("3_05") then
					AreaSetDoorLocked(TRIGGER._DT_Tenement_Window, false)
					AreaSetDoorLocked(TRIGGER._DT_Tenement_Window, false)
					if PedInRectangle(gPlayer,r17,r18,r19,r20) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
						TextPrintString("Press ~TAG_COMBO3~ to enter the tenements",1,2)
					elseif PedInRectangle(gPlayer,r17,r18,r19,r20) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
						AreaTransitionXYZ(36,-544.4,-49.6,31.0)
						--CameraReturnToPlayer()
					end
				end
				if IsMissionCompleated("4_B2") then
					AreaSetDoorLocked(TRIGGER._DT_Observatory, false)
					if PedInRectangle(gPlayer,r9,r10,r11,r12) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
						TextPrintString("Press ~TAG_COMBO3~ to exit the observatory",1,2)
					elseif PedInRectangle(gPlayer,r9,r10,r11,r12) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
						AreaTransitionXYZ(0,48.0,-134.1,3.0)
						--CameraReturnToPlayer()
					elseif PedInRectangle(gPlayer,r13,r14,r15,r16) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
						TextPrintString("Press ~TAG_COMBO3~ to enter the observatory",1,2)
					elseif PedInRectangle(gPlayer,r13,r14,r15,r16) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) then
						AreaTransitionXYZ(40,-696.3,67.0,20.3)
						--CameraReturnToPlayer()
					end
				end
				if IsMissionCompleated("6_B") then
					--AreaSetDoorLocked(TRIGGER._DT_ischool_RoofDoor, false)
					--AreaSetDoorLocked(TRIGGER._DT_ischool_RoofDoor, false)
					--AreaSetDoorLocked(TRIGGER._DT_TSCHOOL_ROOFDOOR, false)
					--AreaSetDoorLocked(TRIGGER._DT_ISCHOOL_ROOFDOOR, false)
					--AreaSetDoorLocked(TRIGGER._ISCHOOL_DOOR25, false)
					AreaSetDoorLocked(TRIGGER._DT_ischool_AuditorDoorL, false)
					AreaSetDoorLocked(TRIGGER._DT_ischool_AuditorDoorL, false)
					AreaSetDoorLocked(TRIGGER._DT_ischool_AuditorBalc, false)
					AreaSetDoorLocked(TRIGGER._5_03_Patient_Room1, false)
					AreaSetDoorLocked(TRIGGER._5_03_Patient_Room2, false)
					AreaSetDoorLocked(TRIGGER._5_03_Patient_Room3, false)
					AreaSetDoorLocked(TRIGGER._DT_ischool_Staff, false)
					if PedInRectangle(gPlayer,r29,r30,r31,r32) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) and not attitudeAdjustment then
						TextPrintString("Press ~TAG_COMBO3~ to toggle clique attitudes to negative",1,2)
					elseif PedInRectangle(gPlayer,r29,r30,r31,r32) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) and not attitudeAdjustment then
						PedSetTypeToTypeAttitude(1,13,1) --nerds
						PedSetTypeToTypeAttitude(2,13,1) --jocks
						PedSetTypeToTypeAttitude(3,13,1) --townies
						PedSetTypeToTypeAttitude(4,13,1) --greasers
						PedSetTypeToTypeAttitude(5,13,1) --preps
						PedSetTypeToTypeAttitude(11,13,1) --bullies
						attitudeAdjustment = true
					elseif PedInRectangle(gPlayer,r29,r30,r31,r32) and not IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) and attitudeAdjustment then
						TextPrintString("Press ~TAG_COMBO3~ to return clique attitudes to being positive",1,2)
					elseif PedInRectangle(gPlayer,r29,r30,r31,r32) and IsButtonBeingPressed(9,0) and not PedIsInAnyVehicle(gPlayer) and attitudeAdjustment then
						PedSetTypeToTypeAttitude(1,13,4) --nerds
						PedSetTypeToTypeAttitude(2,13,4) --jocks
						PedSetTypeToTypeAttitude(3,13,4) --townies
						PedSetTypeToTypeAttitude(4,13,4) --greasers
						PedSetTypeToTypeAttitude(5,13,4) --preps
						PedSetTypeToTypeAttitude(11,13,4) --bullies
						attitudeAdjustment = false
					end
				end
		--Wait(0)
	--end  
end

--F_StartMission = function()

--	ClockSetTickRate(0.0010000000521541)

--	if spawnRoof == false then

--		spawnRoof = true
--		LaunchScript("Test6_B.lua")

--	end
--end

-- STimeCycle:
F_StartClass = function()
	if not IsMissionCompleated("3_08") or IsMissionCompleated("3_08_PostDummy") then
		F_RingSchoolBell() 
	end
end
F_EndClass = function()
	if not IsMissionCompleated("3_08") or IsMissionCompleated("3_08_PostDummy") then
		F_RingSchoolBell()
	end
end
F_AttendedClass = function()
	if not IsMissionCompleated("3_08") or IsMissionCompleated("3_08_PostDummy") then
		SetSkippedClass(false)
		PlayerSetPunishmentPoints(0)
	end
end
F_MissedClass = function()
	if not IsMissionCompleated("3_08") or IsMissionCompleated("3_08_PostDummy") then
		SetSkippedClass(true)
		StatAddToInt(166)
	end
end
F_UpdateTimeCycle = function()
	if not IsMissionCompleated("1_B") then
		local day = GetCurrentDay(false)
		if day < 0 or day > 2 then
			SetCurrentDay(0)
		end
	end
	F_UpdateCurfew()
end
F_UpdateCurfew = function()
	(shared.gCurfewRules or F_CurfewDefaultRules)()
end
F_CurfewDefaultRules = function()
	local t = ClockGet()
	shared.gCurfew = t >= 23 or t < 7
end
F_Nothing = function()
	
end
F_ClassWarning = F_Nothing
F_StartMorning = F_UpdateTimeCycle
F_EndMorning = F_UpdateTimeCycle
F_StartLunch = F_UpdateTimeCycle
F_EndLunch = F_UpdateTimeCycle
F_StartAfternoon = F_UpdateTimeCycle
F_EndAfternoon = F_UpdateTimeCycle
F_StartEvening = F_UpdateTimeCycle
F_EndEvening = F_UpdateTimeCycle
F_StartCurfew_SlightlyTired = F_UpdateTimeCycle
F_StartCurfew_Tired = F_UpdateTimeCycle
F_StartCurfew_MoreTired = F_UpdateTimeCycle
F_StartCurfew_TooTired = F_UpdateTimeCycle
F_EndCurfew_TooTired = F_UpdateTimeCycle
F_EndTired = F_UpdateTimeCycle
